package TiVo::Web::Page;

use strict;
use TiVo::Config;
use File::Path;
use Carp;

our $VERSION =
    (split / /, q$Id: Page.pm,v 1.3 2002/03/18 22:31:04 grant Exp $)[2];

sub new {
    my $class = shift;
    my $self = {};
    bless $self, $class;
    return $self;
}

sub exists {
    my $class = shift;
    my ($station, $day) = @_;
    my $conf = TiVo::Config->new;
    my $path = join('/', $conf->guidedir, 'pages', $day, $station);
    return -e $path;
}

sub save {
    my $self = shift;
    my $conf = TiVo::Config->new;
    my $path = join('/', $conf->guidedir, 'pages', $self->day);
    mkpath($path);
    my $station = $self->station;
    open(my $file, ">$path/$station") or die "failed open for write ($!)";
    print $file $self->content;
    close($file) or die "failed close ($!)";
}

sub load {
    my $self = shift;
    unless (map(defined, $self->day, $self->station)) {
        croak "Page load needs day and station";
    }
    my $conf = TiVo::Config->new;
    my $guide = $conf->guidedir;
    my $filepath = join('/', $guide, 'pages', $self->day, $self->station);
    open(my $file, $filepath) or die "failed open ($!)";
    local $/ = undef;
    $self->content(<$file>);
    close($file) or die "failed close ($!)";
}

sub content {
    my $self = shift;
    if (my $newcontent = shift) {
        $self->{content} = $newcontent;
    }
    return $self->{content};
}

sub day {
    my $self = shift;
    if (my $newday = shift) {
        $self->{day} = $newday;
    }
    return $self->{day};
}

sub station {
    my $self = shift;
    if (my $newstation = shift) {
        $self->{station} = $newstation;
    }
    return $self->{station};
}

1;
